package com.upscapesoft.instasaverapp

import android.app.Application
import android.content.SharedPreferences
import com.onesignal.OneSignal
import com.upscapesoft.instasaverapp.activities.PremiumActivity
import com.upscapesoft.instasaverapp.data.Constants
import com.upscapesoft.instasaverapp.helper.AdController
import com.upscapesoft.instasaverapp.helper.AppOpenManager
import com.upscapesoft.instasaverapp.utils.ThemeSettings

class MyApp : Application() {

    private var appOpenManager: AppOpenManager? = null

    override fun onCreate() {
        super.onCreate()

        ThemeSettings.getInstance(this)!!.refreshTheme()

        // Enable verbose OneSignal logging to debug issues if needed.
        OneSignal.setLogLevel(OneSignal.LOG_LEVEL.VERBOSE, OneSignal.LOG_LEVEL.NONE)

        // OneSignal Initialization
        OneSignal.initWithContext(this)
        OneSignal.setAppId(Constants.ONESIGNAL_APP_ID)
        AdController.initAd(this)
        PremiumActivity.purchaseValueFromPref = preferenceObject.getBoolean(PremiumActivity.PURCHASE_KEY, false)
        if (!PremiumActivity.purchaseValueFromPref!! as Boolean) {
            appOpenManager = AppOpenManager(this)
        }

    }

    private val preferenceObject: SharedPreferences
        get() = applicationContext.getSharedPreferences(PremiumActivity.PREF_FILE, 0)

}