package com.upscapesoft.instasaverapp.activities

import android.annotation.SuppressLint
import android.app.Activity
import android.content.SharedPreferences
import android.os.Bundle
import android.view.View
import androidx.appcompat.app.AppCompatActivity
import com.upscapesoft.instasaverapp.BuildConfig
import com.upscapesoft.instasaverapp.databinding.ActivityAboutBinding
import com.upscapesoft.instasaverapp.helper.AdController

class AboutActivity : AppCompatActivity() {

    private var activity: Activity? = null
    private lateinit var binding: ActivityAboutBinding

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        binding = ActivityAboutBinding.inflate(layoutInflater)
        setContentView(binding.root)
        activity = this

        contentViews()

    }

    @SuppressLint("SetTextI18n")
    private fun contentViews() {
        PremiumActivity.purchaseValueFromPref = preferenceObject.getBoolean(PremiumActivity.PURCHASE_KEY, false)
        if (PremiumActivity.purchaseValueFromPref as Boolean) {
            binding.container.bannerContainer.visibility = View.GONE
        } else {
            /*admob*/
            AdController.loadBannerAd(activity, binding.container.bannerContainer)
            AdController.loadInterAd(activity)
            binding.container.bannerContainer.visibility = View.VISIBLE
        }

        binding.appVersion.text = "Version " + BuildConfig.VERSION_NAME

        binding.backBtn.setOnClickListener {
            onBackPressed()
        }

    }

    private val preferenceObject: SharedPreferences
        get() = applicationContext.getSharedPreferences(PremiumActivity.PREF_FILE, 0)

    override fun onBackPressed() {
        if (PremiumActivity.purchaseValueFromPref as Boolean) {
            super.onBackPressed()
        } else {
            AdController.adCounter++
            if (AdController.adCounter == AdController.adDisplayCounter) {
                AdController.showInterAd(activity, null, 0)
            } else {
                super.onBackPressed()
            }

        }

    }

}