package com.upscapesoft.instasaverapp.activities

import android.annotation.SuppressLint
import android.content.Intent
import android.os.Bundle
import android.os.Handler
import androidx.appcompat.app.AppCompatActivity
import com.upscapesoft.instasaverapp.data.Constants
import com.upscapesoft.instasaverapp.databinding.ActivitySplashBinding

@SuppressLint("CustomSplashScreen")
class SplashActivity : AppCompatActivity() {

    private var activity: SplashActivity? = null
    private lateinit var binding: ActivitySplashBinding

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        binding = ActivitySplashBinding.inflate(layoutInflater)
        setContentView(binding.root)
        activity = this

        contentViews()
        mainScreen()

    }

    private fun contentViews() {
        binding.appNameSplash.alpha = 0f
        binding.appNameSplash.animate()
            .translationY(binding.appNameSplash.height.toFloat())
            .alpha(1f)
            .setDuration(1000)
            .setStartDelay(1000)
            .translationY(binding.appNameSplash.height.toFloat())
            .alpha(1f)
            .setDuration(1200).startDelay = 1500

        binding.companyName.alpha = 0f
        binding.companyName.animate()
            .translationY(binding.companyName.height.toFloat())
            .alpha(1f)
            .setDuration(1000)
            .setStartDelay(1000)
            .translationY(binding.companyName.height.toFloat())
            .alpha(1f)
            .setDuration(1200).startDelay = 1500

        binding.appLoader.alpha = 0f
        binding.appLoader.animate()
            .translationY(binding.appLoader.height.toFloat())
            .alpha(1f)
            .setDuration(1000)
            .setStartDelay(1000)
            .translationY(binding.appLoader.height.toFloat())
            .alpha(1f)
            .setDuration(1200).startDelay = 1500
    }

    @Suppress("deprecation")
    private fun mainScreen() {
        Handler().postDelayed({
            startActivity(Intent(activity, MainActivity::class.java))
            finish()
        }, Constants.SPLASH_SCREEN_TIMEOUT.toLong())

    }

}