package com.upscapesoft.instasaverapp.activities

import android.app.Activity
import android.content.SharedPreferences
import android.os.Bundle
import android.view.View
import android.widget.MediaController
import androidx.appcompat.app.AppCompatActivity
import androidx.core.content.FileProvider
import com.upscapesoft.instasaverapp.BuildConfig
import com.upscapesoft.instasaverapp.databinding.ActivityVideoPlayerBinding
import com.upscapesoft.instasaverapp.helper.AdController
import java.io.File

class VideoPlayerActivity : AppCompatActivity() {

    private var activity: Activity? = null
    private lateinit var binding: ActivityVideoPlayerBinding

    private var videoPath: String? = null

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        binding = ActivityVideoPlayerBinding.inflate(layoutInflater)
        setContentView(binding.root)
        activity = this

        contentViews()

    }

    private fun contentViews() {
        PremiumActivity.purchaseValueFromPref = preferenceObject.getBoolean(PremiumActivity.PURCHASE_KEY, false)
        if (PremiumActivity.purchaseValueFromPref as Boolean) {
            binding.container.bannerContainer.visibility = View.GONE
        } else {
            /*admob*/
            AdController.loadBannerAd(activity, binding.container.bannerContainer)
            AdController.loadInterAd(activity)
            binding.container.bannerContainer.visibility = View.VISIBLE
        }

        videoPath = intent.getStringExtra("videosVid2")

        binding.previewVid.setVideoURI(FileProvider.getUriForFile(activity!!, BuildConfig.APPLICATION_ID + ".fileprovider", File(videoPath!!)))
        val mediaController = MediaController(this)
        mediaController.setAnchorView(binding.previewVid)
        binding.previewVid.setMediaController(mediaController)
        binding.previewVid.start()

        binding.previewVid.setOnCompletionListener {
            finish()
        }

        binding.backBtn.setOnClickListener {
            onBackPressed()
        }

    }

    override fun onResume() {
        super.onResume()
        binding.previewVid.setVideoURI(FileProvider.getUriForFile(activity!!, BuildConfig.APPLICATION_ID + ".fileprovider", File(videoPath!!)))
        binding.previewVid.start()

        binding.previewVid.setOnCompletionListener {
            finish()
        }

    }

    private val preferenceObject: SharedPreferences
        get() = applicationContext.getSharedPreferences(PremiumActivity.PREF_FILE, 0)

    override fun onBackPressed() {
        if (PremiumActivity.purchaseValueFromPref as Boolean) {
            super.onBackPressed()
        } else {
            AdController.adCounter++
            if (AdController.adCounter == AdController.adDisplayCounter) {
                AdController.showInterAd(activity, null, 0)
            } else {
                super.onBackPressed()
            }

        }

    }

}