package com.upscapesoft.instasaverapp.adapters;

import android.app.Activity;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;

import androidx.recyclerview.widget.RecyclerView;

import com.bumptech.glide.Glide;
import com.upscapesoft.instasaverapp.R;
import com.upscapesoft.instasaverapp.helper.Method;
import com.upscapesoft.instasaverapp.interfaces.OnClick;

import org.jetbrains.annotations.NotNull;

import java.io.File;
import java.util.List;

public class FileListAdapter extends RecyclerView.Adapter<FileListAdapter.ViewHolder> {

    private Method method;
    private String string;
    private Activity activity;
    private int columnWidth;
    private List<File> stringList;

    public FileListAdapter(Activity activity, List<File> stringList, String string, OnClick onClick) {
        this.activity = activity;
        this.stringList = stringList;
        this.string = string;
        method = new Method(activity, onClick);
        columnWidth = method.getScreenWidth();
    }

    @NotNull
    @Override
    public ViewHolder onCreateViewHolder(@NotNull ViewGroup parent, int viewType) {
        View view = LayoutInflater.from(activity).inflate(R.layout.file_list_lay, parent, false);
        return new ViewHolder(view);
    }

    @Override
    public void onBindViewHolder(final ViewHolder holder, final int position) {
        Glide.with(activity).load(stringList.get(position).toString()).into(holder.thumbnail);

        holder.playBtn.setVisibility(View.GONE);
        if (string.equals("video")) {
            holder.playBtn.setVisibility(View.VISIBLE);
        }

        holder.thumbnail.setOnClickListener(v -> {
            method.onClick(position, string, "");
        });

    }

    @Override
    public int getItemCount() {
        return stringList.size();
    }

    public class ViewHolder extends RecyclerView.ViewHolder {

        private ImageView thumbnail, playBtn;

        public ViewHolder(View itemView) {
            super(itemView);
            thumbnail = itemView.findViewById(R.id.thumbnail);
            playBtn = itemView.findViewById(R.id.playBtn);

        }
    }
}
