package com.upscapesoft.instasaverapp.adapters

import android.content.Context
import android.view.ViewGroup
import androidx.annotation.StringRes
import androidx.fragment.app.Fragment
import androidx.fragment.app.FragmentManager
import androidx.fragment.app.FragmentStatePagerAdapter
import com.upscapesoft.instasaverapp.R
import com.upscapesoft.instasaverapp.fragments.ImagesFragment
import com.upscapesoft.instasaverapp.fragments.VideosFragment

class FragmentsPagerAdapter(private val mContext: Context, fm: FragmentManager?) :
    FragmentStatePagerAdapter(
        fm!!, BEHAVIOR_RESUME_ONLY_CURRENT_FRAGMENT
    ) {
    override fun getItem(position: Int): Fragment {
        when (position) {
            0 -> {
                return VideosFragment()
            }
            1 -> {
                return ImagesFragment()
            }
        }
        return Fragment()
    }

    override fun destroyItem(viewPager: ViewGroup, position: Int, `object`: Any) {}
    override fun getPageTitle(position: Int): CharSequence {
        return mContext.resources.getString(TAB_TITLES[position])
    }

    override fun getCount(): Int {
        // Show 2 total pages.
        return 2
    }

    companion object {
        @StringRes
        private val TAB_TITLES =
            intArrayOf(R.string.tab_videos, R.string.tab_images)
    }

}